Package org.apache.sysds.runtime.meta

## Class TensorCharacteristics

- java.lang.Object
- - org.apache.sysds.runtime.meta.DataCharacteristics
  - - org.apache.sysds.runtime.meta.TensorCharacteristics

- All Implemented Interfaces:
    `Serializable`

      public class TensorCharacteristics
      extends DataCharacteristics

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int[]` | `DEFAULT_BLOCK_SIZE` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TensorCharacteristics()` |
    `TensorCharacteristics​(long[] dims, int blocksize)` |
    `TensorCharacteristics​(long[] dims, int blocksize, long nnz)` |
    `TensorCharacteristics​(long[] dims, long nnz)` |
    `TensorCharacteristics​(DataCharacteristics that)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `dimsKnown()` |
    `boolean` | `dimsKnown​(boolean includeNnz)` |
    `boolean` | `equalDims​(Object anObject)` |
    `boolean` | `equals​(Object anObject)` |
    `long` | `getCols()` |
    `long` | `getDim​(int i)` |
    `int[]` | `getIntDims()` |
    `long` | `getLength()` |
    `long[]` | `getLongDims()` |
    `long` | `getNonZeros()` |
    `long` | `getNumBlocks()` |
    `long` | `getNumBlocks​(int i)` |
    `int` | `getNumDims()` |
    `long` | `getRows()` |
    `int` | `hashCode()` |
    `boolean` | `nnzKnown()` |
    `DataCharacteristics` | `set​(long[] dims, int blocksize)` |
    `DataCharacteristics` | `set​(long[] dims, int blocksize, long nnz)` |
    `DataCharacteristics` | `set​(DataCharacteristics that)` |
    `DataCharacteristics` | `setDim​(int i, long dim)` |
    `DataCharacteristics` | `setDims​(long[] dims)` |
    `DataCharacteristics` | `setNonZeros​(long nnz)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.apache.sysds.runtime.meta.DataCharacteristics

      `aggregateBinary, aggregateUnary, colsKnown, getBlocksize, getDims, getNonZerosBound, getNumColBlocks, getNumRowBlocks, getSparsity, isNoEmptyBlocks, isUltraSparse, mightHaveEmptyBlocks, reorg, rowsKnown, set, set, setBlocksize, setCols, setDimension, setNoEmptyBlocks, setNonZerosBound, setRows`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_BLOCK_SIZE

          public static final int[] DEFAULT_BLOCK_SIZE

  - ### Constructor Detail

    - #### TensorCharacteristics

          public TensorCharacteristics()

    - #### TensorCharacteristics

          public TensorCharacteristics​(long[] dims,
                                       long nnz)

    - #### TensorCharacteristics

          public TensorCharacteristics​(long[] dims,
                                       int blocksize)

    - #### TensorCharacteristics

          public TensorCharacteristics​(long[] dims,
                                       int blocksize,
                                       long nnz)

    - #### TensorCharacteristics

          public TensorCharacteristics​(DataCharacteristics that)

  - ### Method Detail

    - #### set

          public DataCharacteristics set​(long[] dims,
                                         int blocksize)

      Overrides:
        `set` in class `DataCharacteristics`

    - #### set

          public DataCharacteristics set​(long[] dims,
                                         int blocksize,
                                         long nnz)

      Overrides:
        `set` in class `DataCharacteristics`

    - #### set

          public DataCharacteristics set​(DataCharacteristics that)

      Overrides:
        `set` in class `DataCharacteristics`

    - #### setNonZeros

          public DataCharacteristics setNonZeros​(long nnz)

      Overrides:
        `setNonZeros` in class `DataCharacteristics`

    - #### dimsKnown

          public boolean dimsKnown()

      Overrides:
        `dimsKnown` in class `DataCharacteristics`

    - #### dimsKnown

          public boolean dimsKnown​(boolean includeNnz)

      Overrides:
        `dimsKnown` in class `DataCharacteristics`

    - #### nnzKnown

          public boolean nnzKnown()

      Overrides:
        `nnzKnown` in class `DataCharacteristics`

    - #### getNumDims

          public int getNumDims()

      Overrides:
        `getNumDims` in class `DataCharacteristics`

    - #### getDim

          public long getDim​(int i)

      Overrides:
        `getDim` in class `DataCharacteristics`

    - #### getLongDims

          public long[] getLongDims()

      Overrides:
        `getLongDims` in class `DataCharacteristics`

    - #### getIntDims

          public int[] getIntDims()

      Overrides:
        `getIntDims` in class `DataCharacteristics`

    - #### setDim

          public DataCharacteristics setDim​(int i,
                                            long dim)

      Overrides:
        `setDim` in class `DataCharacteristics`

    - #### setDims

          public DataCharacteristics setDims​(long[] dims)

      Overrides:
        `setDims` in class `DataCharacteristics`

    - #### getLength

          public long getLength()

      Overrides:
        `getLength` in class `DataCharacteristics`

    - #### getNumBlocks

          public long getNumBlocks()

      Overrides:
        `getNumBlocks` in class `DataCharacteristics`

    - #### getNumBlocks

          public long getNumBlocks​(int i)

      Overrides:
        `getNumBlocks` in class `DataCharacteristics`

    - #### getNonZeros

          public long getNonZeros()

      Overrides:
        `getNonZeros` in class `DataCharacteristics`

    - #### getRows

          public long getRows()

      Overrides:
        `getRows` in class `DataCharacteristics`

    - #### getCols

          public long getCols()

      Overrides:
        `getCols` in class `DataCharacteristics`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equalDims

          public boolean equalDims​(Object anObject)

      Specified by:
        `equalDims` in class `DataCharacteristics`

    - #### equals

          public boolean equals​(Object anObject)

      Specified by:
        `equals` in class `DataCharacteristics`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `DataCharacteristics`